# Adding entries
Entry names may only contain normal characters (a-z and uppercase). Anything else will still work but may cause unexpected behavior. 
You may use the translation system of minecraft to localize names and display more characters.
# Adding translations/tooltips
To add translations, better names or tooltips, you need to supply a language file (`en_us.json` for example) 
Normal translations for entries will be named `rpo.<your pack>.<entry>` 
You can also add tooltips with `rpo.tooltip.<your pack>.<entry>`
# Adding an entry
## Toggle/Boolean
To add a boolean entry, add code like this: `"entryName": true` (You can also set it to `false`) inside your `conf` block
## Number box
A number box follows the same principle as a boolean: `"entryName": 10.8` is a possible entry.
## Slider
A slider is slightly more complicated as a minimum and a maximum need to be defined. Sliders also only support whole numbers. 
Example:
```json
"entryName": {
    "min": 15,
    "default": 16,
    "max": 20
}
```
A slider will only be shown if the value names inside the block are exactly the same, otherwise this will be treated as a category.
## Select from list
To allow users to select one entry from a list, you can use a json array with string entries. Numbers/etc are not supported. 
Example:
```json
"entryName": [
    "option_one",
    "option_two",
    "option_three"
]
```
## Categories
A category is a normal json object. It can contain entries of any type, including other categories. 
Example:
```json
"entryName": {
    "someEntry": true,
    "someOtherEntry": 15
}
```
# Example
You can find an example pack configuration [here](https://gitlab.com/jfmods/respackopts/-/blob/master/run/resourcepacks/lumi/assets/respackopts/conf.json)
