# Getting started

Before you can start using respackopts, you will need to create a respackopts conf file for your pack.
This file will be located in `/assets/respackopts/conf.json` of your resource pack (or `/data/respackopts/conf.json` if you are creating a data pack).
You will need to create the respackopts dir yourself. The basic layout is as follows:

```json
{
    "id": "<An identifier for your resource pack>",
    "version": 3,
    "conf": {
        // Your config screen
    }
}
```

Please note that the id as well as any entry should be written in camelCase, while this is technically not required,
I would still recommend it. You add entries by simply putting them inside the "conf" block.
More details of what entries are supported may be found [here](https://gitlab.com/jfmods/respackopts/-/wikis/adding_entries)
Once you have created your config screen, you will need to actually use the entries you defined.
How that is done depends on where you will use them. Generally you can:

* [Enable/Disable certain resources](https://gitlab.com/jfmods/respackopts/-/wikis/conditional) (Example: toggleable texture)
* [Select one of multiple alternative resources](https://gitlab.com/jfmods/respackopts/-/wikis/fallbacks) (Example: select one of many texures)
* [Use values in canvas/frex shaders](https://gitlab.com/jfmods/respackopts/-/wikis/canvas)
* [Replace content in a file based on your config](https://gitlab.com/jfmods/respackopts/-/wikis/expand)

If you are interested in how respackopts works or what changed between versions, you can look [here](https://gitlab.com/jfmods/respackopts/-/wikis/how_it_works)

## Tricks
* Since vanilla minecraft ignores .rpo files, you can use them to load files only if rpo is present by using `"conditions": ["false"]` and a fallback texture (`"true"` is also a key that is always defined in conditional resources)