package io.gitlab.jfronny.respackopts.filters.util;

import io.gitlab.jfronny.respackopts.util.MetaCache;
import io.gitlab.jfronny.respackopts.Respackopts;
import io.gitlab.jfronny.respackopts.util.RpoFormatException;
import net.minecraft.resource.ResourcePack;

public class FileExclusionProvider {
    public static boolean fileHidden(ResourcePack pack, String name) {
        return FileRpoSearchProvider.modifyWithRpo(name, pack, rpo -> {
            if (rpo.conditions == null)
                return false;
            try {
                return !rpo.conditions.evaluate(MetaCache.getId(pack));
            } catch (RpoFormatException e) {
                Respackopts.LOGGER.error("Could not evaluate condition " + name, e);
                return false;
            }
        }, false);
    }
}
