package io.gitlab.jfronny.respackopts.model.condition;

import java.util.List;
import java.util.Set;

public class EqualityConditionFactory implements CollectingConditionFactory {
    @Override
    public Condition build(List<Condition> conditions) {
        return packId -> {
            Boolean b = null;
            for (Condition condition : conditions) {
                if (b == null)
                    b = condition.evaluate(packId);
                else if (b != condition.evaluate(packId))
                    return false;
            }
            return true;
        };
    }

    @Override
    public Set<String> getNames() {
        return Set.of("==", "=", "equal", "eq");
    }
}
