package io.gitlab.jfronny.respackopts.model.condition;

import java.util.List;
import java.util.Set;

public class NorConditionFactory implements CollectingConditionFactory {
    @Override
    public Condition build(List<Condition> conditions) {
        return packId -> {
            for (Condition condition : conditions) {
                if (condition.evaluate(packId))
                    return false;
            }
            return true;
        };
    }

    @Override
    public Set<String> getNames() {
        return Set.of("not", "nor", "!");
    }
}
