package io.gitlab.jfronny.respackopts.model.condition;

import java.util.List;
import java.util.Set;

public class OrConditionFactory implements CollectingConditionFactory {
    @Override
    public Condition build(List<Condition> conditions) {
        return packId -> {
            for (Condition condition : conditions) {
                if (condition.evaluate(packId))
                    return true;
            }
            return false;
        };
    }

    @Override
    public Set<String> getNames() {
        return Set.of("or", "|");
    }
}
