package io.gitlab.jfronny.respackopts.model.tree;

import io.gitlab.jfronny.respackopts.Respackopts;
import me.shedaniel.clothconfig2.api.AbstractConfigListEntry;
import meteordevelopment.starscript.value.Value;

public class ConfigBooleanEntry extends ConfigEntry<Boolean> {
    public ConfigBooleanEntry(boolean v) {
        super(Boolean.class);
        setValue(v);
        setDefault(v);
    }

    @Override
    public ConfigEntry<Boolean> clone() {
        ConfigBooleanEntry be = new ConfigBooleanEntry(getValue());
        be.setDefault(getDefault());
        return be;
    }

    @Override
    public void buildShader(StringBuilder sb, String valueName) {
        if (getValue()) {
            sb.append("\n#define ");
            sb.append(valueName);
        }
    }

    @Override
    public Value buildStarscript() {
        return Value.bool(getValue());
    }

    @Override
    public AbstractConfigListEntry<?> buildEntry(GuiEntryBuilderParam guiEntryBuilderParam) {
        return guiEntryBuilderParam.entryBuilder().startBooleanToggle(guiEntryBuilderParam.name(), getValue())
                .setDefaultValue(getDefault())
                .setSaveConsumer(value -> {
                    if (getValue() != value) {
                        if (Respackopts.CONFIG.debugLogs) Respackopts.LOGGER.info("ConfigBooleanEntry SaveCallback");
                        guiEntryBuilderParam.saveCallback();
                    }
                    setValue(value);
                })
                .setTooltipSupplier(guiEntryBuilderParam.tooltipSupplier())
                .build();
    }
}
